----------Entity------------
local stone_furnace = table.deepcopy(data.raw["furnace"]["stone-furnace"])
stone_furnace.fluid_boxes = {
	{
		production_type = "output",
		pipe_picture = assembler2pipepictures(),
		pipe_covers = pipecoverspictures(),
		base_area = 1,
		base_level = 1,
		pipe_connections = {{type="output", position = {-0.5, -1.5}}},
		secondary_draw_orders = { north = -1 },
	},
off_when_no_fluid_recipe = false,
}
stone_furnace.flags = {
    "placeable-neutral",
    "placeable-player",
    "player-creation",
	--"not-rotatable", works but makes less flexible
}
stone_furnace.crafting_categories = {
	"smelting",
	"industrial-engineering-fluid-smelting",
}

local steel_furnace = table.deepcopy(data.raw["furnace"]["steel-furnace"])
steel_furnace.fluid_boxes = {
	{
		production_type = "output",
		pipe_picture = assembler2pipepictures(),
		pipe_covers = pipecoverspictures(),
		base_area = 1,
		base_level = 1,
		pipe_connections = {{type="output", position = {-0.5, -1.5}}},
		secondary_draw_orders = { north = -1 },
	},
off_when_no_fluid_recipe = false,
}
steel_furnace.flags = {
    "placeable-neutral",
    "placeable-player",
    "player-creation",
	--"not-rotatable", works but makes less flexible
}
steel_furnace.crafting_categories = {
	"smelting",
	"industrial-engineering-fluid-smelting",
}


--data.raw["furnace"]["stone-furnace"] = stone_furnace
data.raw["furnace"]["steel-furnace"] = steel_furnace

----------Item------------
local item_coal_coke = {
    icon = "__industrial-engineering__/graphics/icons/coal-coke.png",
    icon_size = 64,
	name = "industrial-engineering-coal-coke",
	--order
	stack_size = 50,
	--subgroup = "",
	type = "item",
	fuel_value = "6MJ",
	fuel_category = "chemical",
}

local item_treated_wood = {
    icon = "__industrial-engineering__/graphics/icons/treated-wood.png",
    icon_size = 64,
	name = "industrial-engineering-treated-wood",
	--order
	stack_size = 50,
	--subgroup = "",
	type = "item",
	fuel_value = "2.5MJ",
	fuel_category = "chemical",
}

----------Fluid------------
local fluid_creosote = {
    base_color = {b = 47, g = 120, r = 53},
    default_temperature = 25,
    flow_color = {b = 47, g = 120, r = 53},
    heat_capacity = "1KJ",
    icon = "__industrial-engineering__/graphics/icons/fluid/creosote.png",
    icon_mipmaps = 4,
    icon_size = 64,
    max_temperature = 165,
    name = "industrial-engineering-creosote",
    order = "a[fluid]-e[petroleum-gas]",
    type = "fluid",
	fuel_value="0.5MJ",
}

----------Recipe------------
local recipe_coal_coke = {
	category = "industrial-engineering-fluid-smelting",
	enabled = false,
	energy_required = 20,
	icon = "__industrial-engineering__/graphics/icons/coal-coke.png",
	icon_size = 64,
	ingredients = {
		{name = "coal", amount = 1, type = "item"},
	},
	name = "industrial-engineering-coal-coke",
	--order
	results = {
		{name = "industrial-engineering-coal-coke", amount = 1, type = "item"},
		{name = "industrial-engineering-creosote", amount = 1, type = "fluid"},
	},
	type = "recipe",
	subgroup = "raw-material",
}

local recipe_treated_wood = {
	category = "crafting-with-fluid",
	enabled = false,
	energy_required = 0.5,
	--icon = "__industrial-engineering__/graphics/icons/coal-coke.png",
	--icon_size = 64,
	ingredients = {
		{name = "wood", amount = 1, type = "item"},
		{name = "industrial-engineering-creosote", amount = 1, type = "fluid"},
	},
	name = "industrial-engineering-treated-wood",
	--order
	results = {
		{name = "industrial-engineering-treated-wood", amount = 1, type = "item"},
	},
	type = "recipe",
	subgroup = "raw-material",
}

local recipe_rail = {
	enabled = false,
	energy_required = 0.5,
	--icon = "__industrial-engineering__/graphics/icons/coal-coke.png",
	--icon_size = 64,
	ingredients = {
		{name = "industrial-engineering-treated-wood", amount = 1, type = "item"},
		{name = "steel-plate", amount = 1, type = "item"},
		{name = "stone", amount = 1, type = "item"},
	},
	name = "industrial-engineering-rail",
	--order
	results = {
		{name = "rail", amount = 4, type = "item"},
	},
	type = "recipe",
	--subgroup = "raw-material",
}

----------Category------------
data:extend({
  {
    type = "recipe-category",
    name = "industrial-engineering-fluid-smelting",
  }
})

----------Technology------------
local tech_coal_coking = {
	effects = {
		{type = "unlock-recipe", recipe = "industrial-engineering-coal-coke"},
		{type = "unlock-recipe", recipe = "industrial-engineering-treated-wood"},
	},
	icon = "__industrial-engineering__/graphics/technology/coal-coking.png",
	icon_size = 64,
	name = "industrial-engineering-coal-coking",
	--order
	prerequisites = {"fluid-handling"},
	type = "technology",
	unit = {
		count = 100,
		ingredients = {
			{"automation-science-pack", 1},
			{"logistic-science-pack", 1},
		},
		time = 30
	},
}

table.insert(data.raw["technology"]["railway"].effects, {recipe = "industrial-engineering-rail", type = "unlock-recipe"})

----------Add To Game------------
data:extend({
    item_coal_coke,
	item_treated_wood,
	fluid_creosote,
	recipe_coal_coke,
	recipe_treated_wood,
	recipe_rail,
	tech_coal_coking,
})